(function() {

    openerp.widgetInstanceInterest = null;
    openerp.parentInstanceInterest = {};
    var QWeb = openerp.web.qweb;
    var instanceWeb = openerp.web;
    openerp.BankPaymentsInterest = openerp.Widget.extend({
        template: 'verify.Interest',
        id: undefined,
        buttons: undefined,
        bankPayments: [],
        /* init */
        init: function(parent) {
            this._super(parent);
            this.buttons = parent.$buttons;
        },
        /* start */
        start: function () {
            var self = this;
            this.$el.click(function(){
                self.fetchInitial();
            });
            self.buttons.click(function(e) {
                /* C (Crear) */
                if (e.target.accessKey === 'C')
                    self.$el.css('display','none');
                /* E (Editar) */
                if (e.target.accessKey === 'E')
                    self.$el.css('display','none');
                /* S (Guarrdar) */
                if (e.target.accessKey === 'S')
                    self.$el.css('display','flex');
                /* D (Cancelar) */
                if (e.target.accessKey === 'D')
                    self.$el.css('display','flex');
            });
        },
        /* Check state*/
        checkState: function(id, state) {
            var self = this;
            self.id = id;
        },
        /* Reload Page*/
        reloadPage: function() {
            openerp.parentInstanceInterest.reload();
        },
        // /* Método inicial  */
        fetchInitial: function() {
            var self = this;
            self.fetchBankPaymentsJournal(self.id).then(function(bankPayments) {
                return bankPayments;
            }).then(function(bankPayments) {
                self.bankPayments = bankPayments;
                return self.reloadPage();
            });
        },
        fetchBankPaymentsJournal: function(id) {
            var bankStatement = new instanceWeb.Model('res.partner');
            return bankStatement.call('eiru_account_interest_verify',[id],{
                context: new instanceWeb.CompoundContext()
            });
        },
    });

    if (openerp.web && openerp.web.FormView) {
        openerp.web.FormView.include({
            load_record: function(record) {
                this._super.apply(this, arguments);

                if (this.model !== 'res.partner')
                    return;

                openerp.parentInstanceInterest = this;

                if (openerp.widgetInstanceInterest) {
                    openerp.widgetInstanceInterest.checkState(record.id, record.state);
                    if (this.$el.find('.verify-interest-partner').length !== 0)
                        return;
                }

                if (this.$el.find('.verify-interest-partner').length !== 0)
                    return;

                openerp.widgetInstanceInterest = new openerp.BankPaymentsInterest(this);

                var element =this.$el.find('.oe_form').find('.eiru-verify-interest');

                openerp.widgetInstanceInterest.appendTo(element[0]);
                openerp.widgetInstanceInterest.checkState(record.id, record.state);
            }
        });
    }
})();
